﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace TestApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;

            Algomojo.Config config = Algomojo.Config.ReadFromFile("api.config");
            Algomojo.API api = new Algomojo.API(config);

            Algomojo.API.SecurityInfoResponse securityInfo;
            Algomojo.API.LimitResponse limits;
            Algomojo.API.GetQuoteResponse getquote;
            Algomojo.API.FetchtokenResponse fetchtoken;
            Algomojo.API.FetchsymbolResponse fetchsymbol;
            Algomojo.API.LTPCoverpercentageResponse ltpCoverpercentage;
            Algomojo.API.SquareOffPositionResponse squareOffResponse;
            Algomojo.API.PartialPositionconvertionResponse partialPositionconvertion;
            Algomojo.API.PositionBookResponse[] positionBook;
            Algomojo.API.TradeBookResponse[] tradeBook;
            Algomojo.API.OrderBookResponse[] orderBook;
            Algomojo.API.CancelOrderResponse cancelOrder;
            Algomojo.API.ModifyOrderResponse modifyOrder;
            Algomojo.API.ExitCOOrderResponse exitCoOrder;
            Algomojo.API.ExitBOOrderResponse exitBoOrder;
            //Algomojo.API.PlaceMultiBOOrderResponse placeMultiBoOrder;
            Algomojo.API.ErrorResponse error;

            /*api.PlaceMultiBOOrder(new Algomojo.API.PlaceMultiBOOrderRequest(new Algomojo.API.BOOrderData[]
                {
                    new Algomojo.API.BOOrderData("1", "Test Strategy", config.Key, config.Secret, "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "317", "NSE", "B", "DAY", "0", "0", "0", "LTP", "Ticks", "1", "Ticks","1","0","1"),
                    new Algomojo.API.BOOrderData("2", "Test Strategy", config.Key, config.Secret, "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "317", "NSE", "B", "DAY", "0", "0", "0", "LTP", "Ticks", "1", "Ticks","1","0","1")
                }), out error, out placeMultiBoOrder);*/

            api.ExitBOOrder(new Algomojo.API.ExitBOOrderRequest("TS2499", "11122233437", "", "pending"), out error, out exitBoOrder);
            api.ExitCOOrder(new Algomojo.API.ExitCOOrderRequest("TS2499", "111222343445", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML"), out error, out exitCoOrder);

            api.ModifyOrder(new Algomojo.API.ModifyOrderRequest("TS2499", "TS2499", "nse_cm", "RELIANCE-EQ", "990930000011218", "B", "L", "45.52", "0", "0", "0", "DAY", "11184", "0", "CNC", "NA", "DAY", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML"), out error, out modifyOrder);
            api.CancelOrder(new Algomojo.API.CancelOrderRequest("TS2499","990930000011218", "RELIANCE-EQ", "NSE", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML"), out error, out cancelOrder);
            api.OrderBook(new Algomojo.API.OrderBookRequest("BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "TS2499"), out error, out orderBook);
            api.TradeBook(new Algomojo.API.TradeBookRequest("BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "TS2499"), out error, out tradeBook);
            api.PositionBook(new Algomojo.API.PositionBookRequest("TS24XX","TS24XX","DAY", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML"), out error, out positionBook);

            
            api.SquareOffPosition(new Algomojo.API.SquareOffPositionRequest("TS24XX", "TS24XX", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "nse_cm", "CNC", "1", "11915", "YESBANK-EQ", "NEST_REST"), out error, out squareOffResponse);
            api.PartialPositionconvertion(new Algomojo.API.PartialPositionconvertionRequest("TS24XX", "TS24XX", "BO:BO||CNC:CNC||CO:CO||MIS:MIS||NRML:NRML", "nse_cm", "CNC", "1", "11915", "YESBANK-EQ", "NEST_REST"), out error, out partialPositionconvertion);
            api.LTPCoverpercentage(new Algomojo.API.LTPCoverpercentageRequest("NSE", "11184", "B"), out error, out ltpCoverpercentage);
            api.Fetchsymbol("RELIANCE-EQ", out error, out fetchsymbol);
            api.SecurityInfo(new Algomojo.API.SecurityInfoRequest("TS24XX", "NFO", "38818"), out error, out securityInfo);            
            api.Limits(new Algomojo.API.LimitsRequest("TS2499", "TS24XX", "ALL", "NSE", ""), out error, out limits);
            api.GetQuote(new Algomojo.API.GetQuoteRequest("NFO", "RELIANCE-EQ"), out error, out getquote);            
            api.Fetchtoken("RELIANCE-EQ", out error, out fetchtoken);            
        }
    }
}
